#ifndef __BUFFER_H
#define __BUFFER_H

#include <stdint.h>
#include <openssl/ssl.h>

typedef struct _Buffer {
	uint8_t* data;
	size_t data_size;
	SSL* ssl;
} Buffer;

void buffer_init(Buffer* bf);
void buffer_write(Buffer* bf, uint8_t* data, size_t size);
int buffer_send(Buffer* bf);
int buffer_recv(Buffer* bf);
void buffer_truncate(Buffer* bf, size_t size);
void buffer_clear(Buffer* bf);

#endif




