#ifndef __CLIENT_SOCKET_H
#define __CLIENT_SOCKET_H

#include <stdint.h>

#include "buffer.h"

struct _Network;

typedef struct _ClientSocket {
	char* host;
	uint16_t port;
	char connected;
	SSL_CTX *ctx;
	
	int sock;
	SSL* ssl;
	Buffer br;
	Buffer bs;
	
	struct _Network* net;
} ClientSocket;

int cs_init(ClientSocket* cs, const char* host, uint16_t port);
int cs_connect(ClientSocket* cs);
void cs_process_packet(ClientSocket* cs, uint8_t* data, uint32_t size);
void cs_loop(ClientSocket* cs);
void cs_close(ClientSocket* cs, char closed);
void cs_write(ClientSocket* cs, uint8_t* data, size_t size);
void cs_flush(ClientSocket* cs);

#endif


