#include <string.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
#include "buffer.h"

Buffer::Buffer() {
	data = NULL;
	data_size = 0;
}

void Buffer::write(uint8_t* newdata, size_t size) {
	uint8_t * b = (uint8_t*)malloc(data_size+size);
	if(data_size>0) {
		memcpy(b, data, data_size);
		free(data);
	}
	memcpy(b+data_size, newdata, size);
	data_size += size;
	data = b;
}

void Buffer::send() {
	if(data_size==0) return;
	int res = SSL_write(ssl, data, data_size);
	if(res<0) throw 0;
	if(res==0) throw 1;
	truncate(res);
}

void Buffer::recv() {
	uint8_t buffer[10000];
	int res = SSL_read(ssl, buffer, sizeof(buffer));
	if(res<0) throw 0;
	if(res==0) throw 1;
	write(buffer, res);
}

void Buffer::truncate(size_t size) {
	if(data_size==0) return;
	
	if(size>=data_size) {
		free(data);
		data_size = 0;
		return;
	}
	
	uint8_t * b = (uint8_t*)malloc(data_size-size);
	memcpy(b, data+size, data_size-size);
	free(data);
	data = b;
}

