#ifndef __CLIENT_CONNECTION_H
#define __CLIENT_CONNECTION_H

#include <stdint.h>
#include <netinet/in.h>
#include <openssl/ssl.h>

#include "buffer.h"

class Server;

class ClientConnection {
	private:
		Buffer bs;
		Buffer br;
		SSL* ssl;
		Server* server;
		
		void process_packet(uint8_t* data, uint32_t size);
	public:
		int h;
		struct sockaddr_in addr;
		
		ClientConnection(int d, struct sockaddr_in *addr, SSL_CTX *ctx, Server* server);
		void loop();
		void close(bool closed);
		void write(uint8_t* data, size_t size);
};

#endif

