#include <string.h>
#include "mac_table.h"
#include "client_connection.h"

MacTable::MacTable() {
	for(unsigned int i=0;i<MAC_TABLE_SIZE;i++) {
		items[i].valid = false;
	}
}

ClientConnection* MacTable::lookup(uint8_t* mac) {
	for(unsigned int i=0;i<MAC_TABLE_SIZE;i++) {
		if(items[i].valid) {
			if(memcmp(items[i].mac, mac, MAC_SIZE)==0) {
				return items[i].conn;
			}
		}
	}
	return NULL;
}

void MacTable::add(ClientConnection* conn, uint8_t* mac) {
	for(unsigned int i=0;i<MAC_TABLE_SIZE;i++) {
		if(items[i].valid) {
			if(items[i].conn == conn) {
				memcpy(items[i].mac, mac, MAC_SIZE);
				return;
			}
		}
	}
	
	for(unsigned int i=0;i<MAC_TABLE_SIZE;i++) {
		if(!items[i].valid) {
			memcpy(items[i].mac, mac, MAC_SIZE);
			items[i].conn = conn;
			items[i].valid = true;
			return;
		}
	}
	
	fprintf(stderr, "mac table is full\n");
}

void MacTable::del(ClientConnection* conn) {
	for(unsigned int i=0;i<MAC_TABLE_SIZE;i++) {
		if(items[i].valid) {
			if(items[i].conn == conn) {
				items[i].valid = false;
			}
		}
	}
	printf("mac deleted\n");
}
