#ifndef __MAC_TABLE_H
#define __MAC_TABLE_H

#include <stdint.h>

#define MAC_TABLE_SIZE 1000
#define MAC_SIZE 6

#include "client_connection.h"

typedef struct _mac_table_item_t {
	bool valid;
	uint8_t mac[MAC_SIZE];
	ClientConnection* conn;
} mac_table_item_t;

class MacTable {
	private:
		mac_table_item_t items[MAC_TABLE_SIZE];
	public:
		MacTable();
		ClientConnection* lookup(uint8_t* mac);
		void add(ClientConnection* conn, uint8_t* mac);
		void del(ClientConnection* c);
};

#endif


