#ifndef __SERVER_H
#define __SERVER_H

#define FILE_CERT "server.crt"
#define FILE_KEY "server.key"
#define MAX_CONN 100

#include <stdint.h>

#include "client_connection.h"
#include "mac_table.h"

class Server {
	private:
		SSL_CTX *ctx;
		int sock;
		ClientConnection* conns[MAX_CONN];
	public:
		MacTable mt;
		
		Server(const char* host, uint16_t port);
		void loop();
		void close();
		void broadcast(uint8_t* data, size_t size, ClientConnection* me);
		void delete_me(ClientConnection* c);
};

#endif
